% get_z_inverse:
% 
% Given the current mixture indicator values 'z_values', where the number 
% of levels of each mixture indicator is given by pi_z, return a 
% corresponding index for this instantiation.

function value = get_z_inverse(subset, z_values)

if length(subset) ~= length(z_values)
    error('get_z_inverse: length of input vectors has to be the same!');
end

global pi_z;

value = 1;
acc = 1;
n = length(subset);

%for i = n:-1:1
%    value = value + (z_values(i) - 1) * acc;
%    acc = acc * length(pi_z{subset(i)});
%end

for i = 1:n
    value = value + (z_values(i) - 1) * acc;
    acc = acc * length(pi_z{subset(i)});
end