% Generate the non-spouses of each vertex.
% This assumes that the graph is symmetric, graph(i, j) == 1 if
% vertices are adjacent (and graph(i, i) == 0).

function [non_spouses] = generate_nonspouses(graph)

num_vars = length(graph);
non_spouses = cell(num_vars, 1);

for i = 1:num_vars
    graph_row = graph(i, :);
    graph_row(i) = 1;
    non_spouses{i} = find(graph_row == 0);
end
