function [l_posteriorO l2_posteriorO] = lvm_expectation_l()

global graph;
global l_posterior;
global l2_posterior;
global coeffs;
global clique_parents;
global data;
global cliques;
global maximal_z;
global gammas;

num_vars = length(graph);
num_cliques = size(cliques, 1);
sample_size = size(data, 1);

l_posterior = zeros(num_cliques, sample_size, maximal_z);
l2_posterior = zeros(num_cliques, num_cliques, sample_size, maximal_z);

for zi = 1:maximal_z
    z_inst = get_z(1:num_vars, zi);    
    impl_coeff = zeros(num_vars, num_cliques);
    for i = 1:num_vars
        v = z_inst(i);
        impl_coeff(i, clique_parents{i}) = coeffs{i}(:, v);
    end
    impl_mean = lvm_assemble_mean(z_inst);
    gam_matrix = eye(num_vars);
    for i = 1:num_vars
        gam_matrix(i, i) = gammas{i}(z_inst(i));
    end
    for d = 1:sample_size        
        point = data(d, :)' - impl_mean;
        B = impl_coeff' * inv(gam_matrix + impl_coeff * impl_coeff');
        l_posterior(:, d, zi) = B * point;
        l2_posterior(:, :, d, zi) = eye(num_cliques) - B * impl_coeff + B * point * point' * B';
    end
end

l_posteriorO = l_posterior;
l2_posteriorO = l2_posterior;
