function new_coeffs = lvm_optimize_coeffs()

global graph;
global clique_parents;
global num_components;
global l_posterior;
global l2_posterior;
global z_posterior;
global intercepts;
global data;
global maximal_z;

num_vars = length(graph);
sample_size = size(data, 1);
new_coeffs = cell(num_vars, 1);
new_coeffs_den = cell(num_vars, 1);
for i = 1:num_vars
    num_cp = length(clique_parents{i});
    new_coeffs{i} = zeros(num_cp, num_components(i));
    new_coeffs_den{i} = zeros(num_cp, num_cp, num_components(i));
end

for zi = 1:maximal_z
    z_inst = get_z(1:num_vars, zi);
    for d = 1:sample_size
        for i = 1:num_vars
            v = z_inst(i);
            cp = clique_parents{i};
            y = data(d, i) - intercepts{i}(v);
            new_coeffs{i}(:, v) = new_coeffs{i}(:, v) + ...
                                  y * l_posterior(cp, d, zi) * z_posterior(d, zi);
            new_coeffs_den{i}(:, :, v) = new_coeffs_den{i}(:, :, v) + ...
                                         l2_posterior(cp, cp, d, zi) * z_posterior(d, zi);
        end
    end
end

for i = 1:num_vars
    num_v = num_components(i);
    for v = 1:num_v
       new_coeffs{i}(:, v) = inv(new_coeffs_den{i}(:, :, v)) * new_coeffs{i}(:, v);
    end
end

