function new_means = lvm_optimize_means()

global graph;
global num_components;
global l_posterior;
global z_posterior;
global coeffs;
global clique_parents;
global data;
global maximal_z;

num_vars = length(graph);
sample_size = size(data, 1);
new_means = cell(num_vars, 1);
new_means_den = cell(num_vars, 1);
for i = 1:num_vars
    new_means{i} = zeros(num_components(i), 1);
    new_means_den{i} = zeros(num_components(i), 1);
end

for zi = 1:maximal_z
    z_inst = get_z(1:num_vars, zi);    
    for d = 1:sample_size
        for i = 1:num_vars
            v = z_inst(i);
            coeff_sel = coeffs{i}(:, v);
            l_sel = l_posterior(clique_parents{i}, d, zi);
            new_means{i}(v) = new_means{i}(v) + ...
                               (data(d, i)  - coeff_sel' * l_sel) * ...
                               z_posterior(d, zi);
            new_means_den{i}(v) = new_means_den{i}(v) + ...
                                   z_posterior(d, zi);
        end
    end
end

for i = 1:num_vars
    for v = 1:num_components(i)   
        new_means{i}(v) = new_means{i}(v) / new_means_den{i}(v);
    end
end
