% prob_zero:
%
% Returns zero if the joint probability of the mixture components is zero.
%
% Author: Ricardo Silva (ricardo@stats.ucl.ac.uk)
% Last modification: Oct 07 2008
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Inputs/outputs should be self-explanatory.


function output = prob_zero(subset, z_inst)

global pi_z;

output = 1;
n = length(subset);

for i = 1:n
    output = output * pi_z{subset(i)}(z_inst(i));
end
